#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>

#define E1 12134
#define G1 10204
#define A1 9090
#define A1d 8580
#define H1 8099
#define C2 7648
#define C2d 7220
#define D2 6814
#define D2d 6430
#define E2 6069
#define F2 5730
#define G2 5102
#define A2 4545
#define G2d 4815
#define A2d 4291
#define C3 3822
#define P 0
#define End 1

// Timer 1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
  PORTB.3=!PORTB.3;
}
int Bit = 0x00;

int i = 0;
int tanki[31]={C2,D2,D2d,C2,D2,D2d,D2d,F2,G2,D2d,F2,G2,F2,G2,A2,F2,G2,A2,G2d,A2d,C3,G2d,A2d,C3,C3,P,C3,C3,C3,C3,End};
int mario[45]= {E2,E2,P,E2,P,C2,E2,P,
                G2,P,P,G1,P,P,
                C2,P,P,G1,P,P,E1,P,
                P,A1,P,H1,P,A1d,A1,P,
                G1,E2,G2,A2,P,F2,G2,
                P,E2,P,C2,D2,H1,End};
void play()
{
         OCR1AH = (char)(Bit>>8);
         OCR1AL = (char)Bit;
         delay_ms(130);
         #asm("cli")
         delay_ms(40);
         #asm("sei")
         i++;
}
void pause()
{
         #asm("cli")
         delay_ms(200);
         #asm("sei")
         i++;
}

void stop()
{
  #asm("cli")
  PORTB=0x00;
  i=0;
}

void main(void)
{

PORTB=0xFF;
DDRB=0xFF;

PORTD=0xFF;
DDRD=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: CTC top=OCR1A
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;

OCR1AH=0x00;
OCR1AL=0xFB;

OCR1BH=0x00;
OCR1BL=0x00;

TIMSK=0x10;

#asm("sei")

while (1)
      {

         Bit= mario[i];


         if(Bit==1)
         {
            stop();
         }
         if(Bit==0)
         {
            pause();
         }
         else
         {
            play();
         }

      };

}
